%%  demo 1: SpInPHASE(Z is for complex data)
%
%
%  ---------------------------------------------------------------------
%  data description
%  ---------------------------------------------------------------------
%
% Original phase: Gaussian elevation
%
% observation model  z = exp(j phi) + n
%
%%  begin demo

clear all
close all



% stuff
I = sqrt(-1);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%  Exp 1 - peaks
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
M=200;
N=200;
surf=5*peaks(M);
z = exp(I*surf);
% compute the interferogram;
phase = angle(z);
mask = ones(M,N);

%%              PUMA
potential.quantized = 'no';
potential.threshold = 0.5;
tic;
unwrap_phase_PUMA =puma_ho(phase,0.5,'potential',potential,'verbose','no');
toc;
%phi_hat_SpInPHASE = angle(exp(I*(phi_pearls + phi_hat_SpInPHASE )));
t_PUMA = toc;
unwrap_phase_PUMA = unwrap_phase_PUMA.*mask;

numberpix = sum(sum(mask));
ttemp = round(sum(sum((unwrap_phase_PUMA-surf).*mask))/(2*pi*numberpix));
unwrap_phase_PUMA = unwrap_phase_PUMA-ttemp*2*pi;

unwrap_err = (unwrap_phase_PUMA-surf).*mask;
errmask = abs(unwrap_err)>pi;
AverageError_PUMA = sqrt(sum(sum((unwrap_phase_PUMA-surf).^2.*mask))/numberpix);
NELP_PUMA = sum(errmask(:));
%%                QPBOI
potential.quantized = 'no';
potential.threshold = 0.5;
tic;
unwrap_phase_QPBOI =QPBOI(phase,0.5,'potential',potential,'base',mask);
toc;
%phi_hat_SpInPHASE = angle(exp(I*(phi_pearls + phi_hat_SpInPHASE )));
t_QPBOI = toc;
unwrap_phase_QPBOI = unwrap_phase_QPBOI.*mask;

numberpix = sum(sum(mask));
ttemp = round(sum(sum((unwrap_phase_QPBOI-surf).*mask))/(2*pi*numberpix));
unwrap_phase_QPBOI = unwrap_phase_QPBOI-ttemp*2*pi;

unwrap_err = (unwrap_phase_QPBOI-surf).*mask;
errmask = abs(unwrap_err)>pi;
AverageError_QPBOI = sqrt(sum(sum((unwrap_phase_QPBOI-surf).^2.*mask))/numberpix);
NELP_QPBOI = sum(errmask(:));
%%                  Goldstein branch cut
gmask = mask;
gmask(1,:)=0;gmask(end,:)=0;gmask(:,1)=0;gmask(:,end)=0;
max_box_radius=4;                           %Maximum search box radius (pixels)
threshold_std=5;                            %Number of noise standard deviations used for thresholding the magnitude image
tic;
residue_charge=PhaseResidues(phase, mask);                            %Calculate phase residues
branch_cuts=BranchCuts(residue_charge, max_box_radius, mask);            %Place branch cuts
[unwrap_phase_Goldstein, rowref, colref]=FloodFill(phase, branch_cuts, mask);   %Flood fill phase unwrapping
toc;

t_GoldsteinCut = toc;
unwrap_phase_Goldstein = unwrap_phase_Goldstein.*gmask;

numberpix = sum(sum(gmask));
ttemp = round(sum(sum((unwrap_phase_Goldstein-surf).*gmask))/(2*pi*numberpix));
unwrap_phase_Goldstein = unwrap_phase_Goldstein-ttemp*2*pi;

unwrap_err = (unwrap_phase_Goldstein-surf).*gmask;
errmask = abs(unwrap_err)>pi;
AverageError_Goldstein = sqrt(sum(sum((unwrap_phase_Goldstein-surf).^2.*gmask))/numberpix);
NELP_Goldstein = sum(errmask(:));
%%                    Snaphu
z = exp(1i*phase);
realz = real(z);
imagz = imag(z);
realz1 = reshape(realz,1,M*N);
imagz1 = reshape(imagz,1,M*N);
write1 = [realz1;imagz1];
writedata = reshape(write1,2*M,N);

mask1 =  reshape(mask,1,M*N);
write2 = [mask1;mask1];
writemask = reshape(write2,2*M,N);
if exist('tmpwph.dat','file')
    dos('del tmpwph.dat');
end
fdin = fopen('tmpwph.dat', 'w');
%  number nodes
if 2*M*N ~= fwrite(fdin, writedata, 'float')
   fprintf(2,'Error wrinting to tmpwph.dat');
   fclose(fdin);
   return;
end
fclose(fdin);
fprintf('finish wrinting to tmpwph.dat\n');

if exist('tmpmask.dat','file')
    dos('del tmpmask.dat');
end
fdin1 = fopen('tmpmask.dat', 'w');
%  number nodes
if 2*M*N ~= fwrite(fdin1, writemask, 'float')
   fprintf(2,'Error wrinting to tmpmask.dat');
   fclose(fdin1);
   return;
end
fclose(fdin1);
fprintf('finish wrinting to tmpmask.dat\n');

if exist('snaphu.out','file')
    dos('del snaphu.out');
end
st = computer; %teste machine
if strcmp(st,'PCWIN64' )
    tic;
    !snaphu_win\win64\snaphu.exe -c tmpmask.dat tmpwph.dat 200
    toc;
elseif strcmp(st,'PCWIN' )
    tic;
    !snaphu_win\win32\snaphu.exe -c tmpmask.dat tmpwph.dat 200
    toc;
else
    fprintf('\nThis code run only on PC\n')
end
clear st;

t_Snaphu = toc;
fid = fopen( 'snaphu.out', 'r' );
if fid == -1
	error( ['Cannot open file ' results_fname] );
end

label_size = 'float';
unwrap = fread( fid, label_size );
fclose(fid);
unwrap = reshape(unwrap,2*M,N);
unwrap = unwrap(M+1:2*M,:);

unwrap_phase_Snaphu = unwrap.*mask;

numberpix = sum(sum(mask));
ttemp = round(sum(sum((unwrap_phase_Snaphu-surf).*mask))/(2*pi*numberpix));
unwrap_phase_Snaphu = unwrap_phase_Snaphu-ttemp*2*pi;

unwrap_err = (unwrap_phase_Snaphu-surf).*mask;
errmask = abs(unwrap_err)>pi;
AverageError_Snaphu = sqrt(sum(sum((unwrap_phase_Snaphu-surf).^2.*mask))/numberpix);
NELP_Snaphu = sum(errmask(:));




fprintf('\n\n------Output Information------\n');
fprintf('AverageError_PUMA  = %2.3f\n', AverageError_PUMA);
fprintf('NELP_PUMA = %2.3f\n', NELP_PUMA);
fprintf('time of computation PUMA: %f\n',t_PUMA);

fprintf('\n\n------Output Information------\n');
fprintf('AverageError_QPBOI  = %2.3f\n', AverageError_QPBOI);
fprintf('NELP_QPBOI = %2.3f\n', NELP_QPBOI);
fprintf('time of computation QPBOI: %f\n',t_QPBOI);

fprintf('\n\n------Output Information------\n');
fprintf('AverageError_Goldstein  = %2.3f\n', AverageError_Goldstein);
fprintf('NELP_Goldstein = %2.3f\n', NELP_Goldstein);
fprintf('time of computation Goldstein: %f\n',t_GoldsteinCut);

fprintf('\n\n------Output Information------\n');
fprintf('AverageError_snaphu  = %2.3f\n', AverageError_Snaphu);
fprintf('NELP_snaphu = %2.3f\n', NELP_Snaphu);
fprintf('time of computation snaphu: %f\n',t_Snaphu);
figure(1);
surfl(unwrap_phase_PUMA.*mask);shading interp;axis off;colormap gray;
figure(2);
surfl(unwrap_phase_QPBOI.*mask);shading interp;axis off;colormap gray;
figure(3);
surfl(unwrap_phase_Goldstein.*gmask);shading interp;axis off;colormap gray;
figure(4);
surfl(unwrap_phase_Snaphu.*mask);shading interp;axis off;colormap gray;




